/********************************************************/
/*							*/
/*	Defining minimal data-base contents for first	*/
/*	clement installation.				*/
/*							*/
/********************************************************/

#ifdef POSTGRESQL
#define	ADDTIME(x)	'x'
#endif
#ifdef MYSQL
#define	ADDTIME(x)	INTERVAL x
#endif
/********************************************************/
/*							*/
/*	Defining default IP/port binding		*/
/*							*/
/********************************************************/
#ifdef WITHIPV4		/*IPV4 Interface			*/
INSERT INTO binding (protocol,active,binding,port,iteration) VALUES
('smtp',1,'127.0.0.1',SMTPPORT0,3);	/*local service		*/
INSERT INTO binding (protocol,active,binding,port,iteration) VALUES
('smtp',1,SMTPIPV4,SMTPPORT0,6);	/*public service	*/
INSERT INTO binding (protocol,active,binding,port,iteration) VALUES
('smtp',1,SMTPIPV4,SMTPPORT1,2);	/*private service	*/
#ifdef SMTPPORT2
INSERT INTO binding (protocol,active,binding,port,iteration) VALUES
('smtp',1,SMTPIPV4,SMTPPORT2,2);	/*other private service	*/
#endif
#ifdef SMTPPORT3
INSERT INTO binding (protocol,active,binding,port,iteration) VALUES
('smtps',1,SMTPIPV4,SMTPPORT3,2);	/*other private service	*/
#endif
#endif
#ifdef WITHIPV6		/*IPV6 Interface			*/
INSERT INTO binding (protocol,active,binding,port,iteration) VALUES
('smtp',1,'::1',SMTPPORT0,3);	/*local service		*/
INSERT INTO binding (protocol,active,binding,port,iteration) VALUES
('smtp',1,SMTPIPV6,SMTPPORT0,6);	/*public service	*/
INSERT INTO binding (protocol,active,binding,port,iteration) VALUES
('smtp',1,SMTPIPV6,SMTPPORT1,2);	/*private service	*/
#ifdef SMTPPORT2
INSERT INTO binding (protocol,active,binding,port,iteration) VALUES
('smtp',1,SMTPIPV6,SMTPPORT2,2);	/*other private service	*/
#endif
#ifdef SMTPPORT3
INSERT INTO binding (protocol,active,binding,port,iteration) VALUES
('smtps',1,SMTPIPV6,SMTPPORT3,2);	/*other private service	*/
#endif
#endif
/********************************************************/
/*							*/
/*	Defining default binding group using default	*/
/*	group number (1).				*/
/*							*/
/********************************************************/
INSERT INTO clmbind SELECT 1,bindid FROM binding;

/********************************************************/
/*							*/
/*	Inserting local default domain and a minimal 	*/
/*	user set.					*/
/*							*/
/********************************************************/
INSERT INTO domain (domainname,upto,updated)
		VALUES (DOMAINNAME,NOW()+ADDTIME(1 year),NOW());
INSERT INTO domainalias (domainaliased,domainname)
		VALUES (HOSTNAME,DOMAINNAME);
INSERT INTO domainalias (domainaliased,domainname)
		VALUES ('localhost.localdomain',DOMAINNAME);
INSERT INTO users (username,password,active,prfid,first,upto,realname) VALUES 
	(ROOTDOMAIN,RPASS,1,2,NOW(),NOW()+ADDTIME(3 year),'Email root account');
INSERT INTO aliases VALUES (DOMAINNAME,'postmaster',1,2,ROOTDOMAIN);
INSERT INTO aliases VALUES (DOMAINNAME,'abuse',1,2,ROOTDOMAIN);
INSERT INTO aliases VALUES (DOMAINNAME,'clement',1,2,ROOTDOMAIN);
INSERT INTO admin (groupid,username) VALUES
	(0,ROOTDOMAIN);
/********************************************************/
/*							*/
/*	Inserting updating default contract name to be	*/
/*	the main local domain name.			*/
/*							*/
/********************************************************/
UPDATE clmgroup SET groupname=GROUPNAME,clemserver=CLEMDOMAIN WHERE groupid=1;
UPDATE clmgroup SET quarantine=NOW();
/********************************************************/
/*							*/
/*	Iserting a local override to reach postmaster	*/
/*	from everywhere.				*/
/*							*/
/********************************************************/
INSERT INTO overrides (ovrride,orgname,orgdom,orgip,recname,recdom)
	VALUES (2,'*','*','0/0','postmaster',DOMAINNAME);
INSERT INTO overrides (ovrride,orgname,orgdom,orgip,recname,recdom)
	VALUES (2,'*','*','0/0','root',DOMAINNAME);
