#!/bin/sh 
#
# statistic,	This shell script will put statistical
#		collected data within an RRD file
#
# parametter format is
# CONTRACT DOMAIN D1 D2 ..... DX
#
# CONTRACT and DOMAIN can be the reserved word "ALL"
#
#----------------------------------------------------------
#the base directory
#----------------------------------------------------------
#local Variable
base=$1		#is the working base.
STATS="stats"
#----------------------------------------------------------
#extracting the WORKING base
. `dirname $0`/version.sh
WRKDIR=$base/var/lib/$APPNAME-$VERS/stats
#----------------------------------------------------------
#creating first file
#$1 CONTRACT
#$2 DOMAIN
#$3 hourly/minutly
dofile() {

if [ ! -f $WRKDIR/$1/$2/$3 ] ; then
#create a file keeping
#	1 Minute information for 5 hours
#	5 Minute information for 24 hours
#	30 Minute information for 1 week
#	2 hour information for 1 month
#	1 day information for 1 year
  /usr/bin/rrdtool create $WRKDIR/$1/$2/$3 -b "now-600" --step 60 \
	DS:vol_in:GAUGE:360:0:U \
	DS:vol_out:GAUGE:360:0:U \
	DS:direct:GAUGE:360:0:50000 \
	DS:relayed:GAUGE:360:0:50000 \
	DS:quarantine:GAUGE:360:0:50000 \
	DS:rejected:GAUGE:360:0:50000 \
	DS:empty:GAUGE:360:0:50000 \
	DS:virus:GAUGE:360:0:50000 \
  	RRA:AVERAGE:0.5:1:300 \
  	RRA:AVERAGE:0.5:5:288 \
	RRA:AVERAGE:0.5:30:336 \
	RRA:AVERAGE:0.5:120:372 \
	RRA:AVERAGE:0.5:1440:365
  fi
}
#----------------------------------------------------------
#checking if directory contract exist
#$1 contract
dodir() {

if [ ! -d $WRKDIR/$1 ] ; then
  mkdir -p $WRKDIR/$1
  fi
}
#----------------------------------------------------------
#doing statistic collection
for TEMPO in minutly hourly
  do
  FILE=$WRKDIR"/stats.$TEMPO"
  # echo "reading file $FILE"
  if [ -f $FILE ] ; then 
    while read -r CONTRAT DOMAIN DATA 
      do
      dodir $CONTRAT/$TEMPO
      dofile $CONTRAT $TEMPO $DOMAIN
      /usr/bin/rrdtool update $WRKDIR/$CONTRAT/$TEMPO/$DOMAIN $DATA
      done < $FILE
    mv $FILE $base/tmp/stats.$TEMPO
    rm -f $FILE
    fi
  done
#----------------------------------------------------------
