#! /bin/sh
#---------------------------------------------------
#shell script to make trouble explaination to be
#send to a rebounce or warning email.
#script is called by clement (unique.c/que_reporttrouble).
#this script can be used to change report wording
#$1 WARNING|TROUBLE|WSUBJECT|TSUBJECT
#
# WARNING 
# $2 Lang  (1 English, 2 French)
# $3 is in trouble Email recipient 
# $4 is the email session number
# $5 is the email subject
# $6 remote server returning the error
# $7 is the status as returned by remote server
#
# TROUBLE 
# $2 Lang  (1 English, 2 French)
# $3 is in trouble Email recipient 
# $4 is the email session number
# $5 is the email subject
# $6 remote server returning the error
# $7 is the status as returned by remote server
# $8 for how long we try in minutes
# $9 upto when do we try to send email
#
# WSUBJECT
# $2 Lang  (1 English, 2 French)
# $3 is the email subject
#
# TSUBJECT
# $2 Lang  (1 English, 2 French)
# $3 is the email subject
#
#---------------------------------------------------
#loading configuration
. `dirname $0`/version.sh

#---------------------------------------------------
#delay report in English or French
# $1 is in trouble Email recipient 
# $2 is the email session number
# $3 is the email subject
# $4 remote server returning the error
# $5 is the status as returned by remote server
# $6 for how long we try in minutes
# $7 upto when do we try to send email
english_delay ()

{
echo -e "To:\t\t<$1>"
echo -e "subject:\t$3"
echo -e "Session-ID:\t$2"
echo -e ""
echo -e "Warning:"
echo "Email process was not able to deliver you email to <$1> within"
echo "the last $6 minutes, You have nothing to do, email process will"
echo "try to send it again and again until, -`date -d @$7`-"
echo -e ""
echo -e "Current status as reported by <$4> acting as recipient's server"
echo -e "\t\"$5\""
echo -e ""
}

french_delay ()

{
echo -e "A:\t\t<$1>"
echo -e "Sujet:\t\t$3"
echo -e "Session-ID:\t$2"
echo -e ""
echo -e "Avertissement:"
echo "Votre courrier n'a pas ete livre a <$1> dans les $6 dernieres minutes"
echo "le serveur de courrier va perseverer et essayer regulierement"
echo "de transmettre votre courrier jusqu'au: -`LANG=fr_FR.UTF-8 date +\"%A %e %B %Y, %H:%M\" -d @$7`-."
echo -e ""
echo -e "Statut courant tel qu'affiche par <$4> serveur designe du destinataire"
echo -e "\t\"$5\""
echo -e ""
}

#---------------------------------------------------
#trouble report in English or French
# $1 is in trouble Email recipient 
# $2 is the email session number
# $3 is the email subject
# $4 remote server returning the error
# $5 is the status as returned by remote server
english_trouble ()

{
echo "Email process was UNABLE to deliver your email"
echo -e "To:\t\t<$1>"
echo -e "subject:\t$3"
echo -e "Session-ID:\t$2"
echo -e ""
echo -e "Fatal status as reported by <$4> acting as recipient's server"
echo -e "\t\"$5\""
echo -e ""
}


french_trouble ()

{
echo "Votre courrier n'a PAS ete remis au destinataire"
echo -e "A:\t\t<$1>"
echo -e "Sujet:\t\t$3"
echo -e "Session-ID:\t$2"
echo -e ""
echo -e "Statut final tel qu'affiche par <$4> serveur designe du destinataire <$4>"
echo -e "\t\"$5\""
echo -e ""
}

#---------------------------------------------------
#main program
status=0	#lets say OK first

case "$1" in
  "WARNING"	)
    case $2 in
      2	  	)
        french_delay $3 $4 "$5" "$6" "$7" $8 $9 | expand
        ;;
      1   	|		\
      *		)
        english_delay $3 $4 "$5" "$6" "$7" $8 $9 | expand
        ;;
      esac
    ;;
  "TROUBLE"	)
    case $2 in
      2	  	)
        french_trouble $3 $4 "$5" "$6" "$7" | expand
        ;;
      1   	|		\
      *		)
        english_trouble $3 $4 "$5" "$6" "$7" | expand
        ;;
      esac
    ;;
  "WSUBJECT"	)
    case $2 in
      2	  	)
        echo -e "Impossible de transmettre immediatement votre courrier ($3)" | expand
        ;;
      1   	|		\
      *		)
        echo -e "Unable to quickly send your email ($3)" | expand
        ;;
      esac
    ;;
  "TSUBJECT"	)
    case $2 in
      2	  	)
        echo -e "Rapport d'erreur au sujet de votre courriel ($3)" | expand
        ;;
      1   	|		\
      *		)
        echo -e "Error report about your Email ($3)" | expand
        ;;
      esac
    ;;
  "" | *	)	
    echo "$0 Unexpected \"$1\" paramater"
    ;;
  esac
#---------------------------------------------------
exit $status
