#! /bin/sh
#------------------------------------------------------------------
#Procedure to clean the database of old journals, data base entry for mails,
# and unclaimed quarantines.
#------------------------------------------------------------------
#setting up default env variable.
. `dirname $0`/../shell/version.sh
#time variables are in /etc/sysconfig/clement
. $BASE/etc/sysconfig/$APPNAME

flagdbg=0
if [ -z $timeQuar ] ; then
  flagdbg=1
elif [ $timeQuar -le '0' ] ; then
  flagdbg=1
fi

if [ -z $timeJrl ] ; then
  flagdbg=1
elif [ $timeJrl -le '0' ] ; then
  flagdbg=1
fi

if [ -z $timeDB ] ; then
  flagdbg=1
elif [ $timeDB -le '0' ] ; then
  flagdbg=1
fi


if [ $flagdbg = 1 ] ; then
echo "ERROR: One or more variables are missing in $BASE/etc/sysconfig/$APPNAME."
echo "timeJrl=$timeJrl.	timeDB=$timeDB.	timeQuar=$timeQuar."
exit
fi

if [ -z "$DB_TYPE" ] ; then
  DB_TYPE=POSTGRESQL;
  fi

#Then the data-base name
if [ -z "$DB_NAME" ] ; then
  DB_NAME=$APPNAME;
  fi

case "$DB_TYPE" in
  "POSTGRESQL"  )
     if [ ! -z "$DB_PORT" ] ; then
       SQLPORT="-p $DB_PORT"
       fi
     if [ ! -z "$DB_HOST" ] ; then
       SQLHOST="-h $DB_HOST"
       fi
     ;;
  "MYSQL"       )
     if [ ! -z "$DB_PORT" ] ; then
       SQLPORT="-P $DB_PORT"
       fi
     if [ ! -z "$DB_HOST" ] ; then
       SQLHOST="-h $DB_HOST"
       fi
     ;;
  esac
#----------------------------------------------
#procedure to probe data-base qith an SQL request
#as $1 parametere
prob_db()

{
case "$DB_TYPE" in
  "POSTGRESQL"  )
     echo "$1" | psql -t -q  -A -F ' ' $SQLPORT $SQLHOST $DB_NAME
     ;;
  "MYSQL"       )
     echo "$1" | mysql -s -u $APPNAME $SQLPORT $SQLHOST $DB_NAME
     ;;
  esac
}
#-------------------------------------------------------
#to compute interval time
getdelay()
#$1 delay

{
case "$DB_TYPE" in
  "POSTGRESQL"  )
    echo "'$1'";
    ;;
  "MYSQL"       )
    echo "INTERVAL $1";
    ;;
  esac
}
#-------------------------------------------------------


#Lock procedure
LOCK=/tmp/daily.sh.$APPNAME-$VERS.lock
trap "rm -f $LOCK ; exit 1" 1 2 3 15
if [ `id -u` = 0 ] ; then
  /bin/echo "archiving.sh, Can't be executed as root"
  exit
  fi

lockfile -1 -r3 $LOCK
if [  $? -ne 0 ] ; then
  /bin/echo "Unable to lock file $LOCK"
  exit 1
  fi

#Procedure in archive, clearing up old journals.
if [ `id -nu` = "clement" ]; then
	if [ -w $BASE/var/spool/$APPNAME-$VERS/logs ] ; then
	 if [ -w $BASE/var/spool/$APPNAME-$VERS/logs/Old ] ; then  
		cd $BASE/var/spool/$APPNAME-$VERS/logs 
		yeartime=`find . -maxdepth 2 -name "*-*.jrl*" |  cut -f 2 -d "-" | cut -b1-4 | sort -n | uniq`
		(for year in $yeartime
		  do
		  mkdir -p $BASE/var/spool/$APPNAME-$VERS/logs/Old/$year
		  find . -maxdepth 1 -name "*$year*.jrl"  -mtime +$timeJrl -exec mv {} Old \;
		  find ./Old -maxdepth 1 -name "*.jrl" -exec gzip -f {} \;
		  find ./Old -maxdepth 1 -name "*.jrl.gz" -exec mv {} ./Old/$year \; 
		  done
		)
	 else
		mkdir -p $BASE/var/spool/$APPNAME-$VERS/logs/Old  
	 fi  
	fi
#clearing old email logs in database
        daydelay=`getdelay "-$timeDB day"`
        prob_db "DELETE FROM emlogs WHERE stamp<NOW()+$daydelay"
#clearing old transit logs in database
        prob_db "DELETE FROM emltrt WHERE first<NOW()+$daydelay"
#clearing old session logs in database
        sesdelay=`getdelay "-$timeJrl day"`
        prob_db "DELETE FROM seslogs WHERE stamp<NOW()+$sesdelay"

#clearing old quarantine
	if [ -w $BASE/var/spool/$APPNAME-$VERS/mails ] ; then
		cd $BASE/var/spool/$APPNAME-$VERS/mails
        	find . -wholename "*/quarantine/*" -mtime +$timeQuar -exec rm {} \;
	fi

#clearing old transit
	if [ -w $BASE/var/spool/$APPNAME-$VERS/transit ] ; then
		cd $BASE/var/spool/$APPNAME-$VERS/transit
        	find . -mtime +10 -exec rm {} \;
	fi

else
echo "Executing user need to be Clement"
fi

#remove lock
rm -f $LOCK

