#! /bin/sh
#-------------------------------------------------------------
#procedure to detect user with the deleted flag and move the whole
#directory contents to a "tobedeleted" drectory.
#-------------------------------------------------------------
#setting the basic definition
. `dirname $0`/../shell/version.sh

#number of day to keep deleted data.
KEEPDELETED=10
#-------------------------------------------------------------
#loading the variable value
. $BASE/etc/sysconfig/$APPNAME

#setting the Variable
#first the Data-base type
if [ -z "$DB_TYPE" ] ; then
  DB_TYPE=POSTGRESQL;
  fi

#Then the data-base name
if [ -z "$DB_NAME" ] ; then
  DB_NAME=$APPNAME;
  fi

#-------------------------------------------------------------
case "$DB_TYPE" in
  "POSTGRESQL"  )
     if [ ! -z "$DB_PORT" ] ; then
       SQLPORT="-p $DB_PORT"
       fi
     if [ ! -z "$DB_HOST" ] ; then
       SQLHOST="-h $DB_HOST"
       fi
     ;;
  "MYSQL"       )
     if [ ! -z "$DB_PORT" ] ; then
       SQLPORT="-P $DB_PORT"
       fi
     if [ ! -z "$DB_HOST" ] ; then
       SQLHOST="-h $DB_HOST"
       fi
     ;;
  esac

#----------------------------------------------
#procedure to probe data-base qith an SQL request
#as $1 parametere
prob_db()

{
case "$DB_TYPE" in
  "POSTGRESQL"  )
     echo "$1" | psql -t -q  -A -F ' ' $SQLPORT $SQLHOST $DB_NAME
     ;;
  "MYSQL"       )
     echo "$1" | mysql -s -u $APPNAME $SQLPORT $SQLHOST $DB_NAME
     ;;
  esac
}

#----------------------------------------------
HOME=$BASE/var/spool/$APPNAME-$VERS/
OWNER=`ls -ld $HOME | cut -d' ' -f3`
if [ `id -nu` = "$OWNER" ]; then
#find out about all user with the deleted flag.
  finddelete=`prob_db "SELECT username FROM users WHERE active=3;"`
  for user in $finddelete
    do
    domain=`echo $user | cut -d'@' -f2`
    name=`echo $user | cut -d'@' -f1`
    echo $domain $name
    mkdir -p $HOME/deleted/$domain
    if [ -d $HOME/mails/$domain/$name ] ; then
      mv $HOME/mails/$domain/$name $HOME/deleted/$domain
      touch $HOME/deleted/$domain/$name
      fi
    case "$DB_TYPE" in
      "POSTGRESQL"  )
	spe_user=`echo $user | sed -e "s/'/''/" `
 	;;
      "MYSQL"       )
	spe_user=`echo $user | sed -e 's/'\''/\\\\'\''/'`
 	;;
      esac
    prob_db "DELETE FROM multipath WHERE i_email='$spe_user'"
    prob_db "DELETE FROM users WHERE username='$spe_user' AND active=3"
    done
  #deleting domain and group with active = todelete
  prob_db "DELETE FROM domain WHERE active=3"
  prob_db "DELETE FROM clmgroup WHERE active=3"
  if [ -w $HOME/deleted ] ; then
    cd $HOME/deleted
    find . -depth -maxdepth 2 -type d				\
	\( -name "[a-z]*" -o -name "[A-Z]*" -o -name "[0-9]*" \)\
	-mtime +$KEEPDELETED 					\
	-exec rm -fr {} \;
    fi
  else
    echo "Executing user need to be $APPNAME"
  fi

