#! /bin/sh
#-------------------------------------------------------------
#procedure to set a database benchmark contents
#test purpose only
#$* is the list of file to install
#within the database
#-------------------------------------------------------------
#setting the basic definition
BASE=$1
. `dirname $0`/../shell/version.sh

#-------------------------------------------------------------
#loading the variable value
. $BASE/etc/sysconfig/$APPNAME

#setting the Variable
#first the Data-base type
if [ -z "$DB_TYPE" ] ; then
  DB_TYPE=POSTGRESQL;
  fi

#Then the data-base name
if [ -z "$DB_NAME" ] ; then
  DB_NAME=$APPNAME;
  fi
#-------------------------------------------------------------
#moving to the right directory
cd $1
LOG=$BASE/etc/$APPNAME-$VERS/dbinst.log
DBSQL=$BASE/etc/$APPNAME-$VERS/dbinst.sql
#building data_base
case "$DB_TYPE" in 
  "POSTGRESQL"	)
     SQL="psql -q"
     if [ ! -z "$DB_PORT" ] ; then
       SQLPORT="-p $DB_PORT"
       fi
     if [ ! -z "$DB_HOST" ] ; then
       SQLHOST="-h $DB_HOST"
       fi
     ;;
  "MYSQL"	)
     SQL="mysql -u root"
     if [ ! -z "$DB_PORT" ] ; then
       SQLPORT="-P $DB_PORT"
       fi
     if [ ! -z "$DB_HOST" ] ; then
       SQLHOST="-h $DB_HOST"
       fi
     ;;
  esac
shift 1;
if [ -n "$SMTPIPV4" ] ; then 
  export WITHIPV4="-DWITHIPV4=1"
  fi
if [ -n "$SMTPIPV6" ] ; then 
  export WITHIPV6="-DWITHIPV6=1"
  fi
if [ -n "$SMTPPORT2" ] ; then 
  export ONESMTPPORT2="-DSMTPPORT2='$SMTPPORT2'"
  fi
if [ -n "$SMTPPORT3" ] ; then 
  export ONESMTPPORT3="-DSMTPPORT3='$SMTPPORT3'"
  fi
for fichier in $* 
  do
  (
  /bin/echo "/*********************************************/"
  /bin/echo "/* File added to data-base config 		  */"
  /bin/echo "/*" $fichier "*/"
  )  >>  $DBSQL
  cpp -traditional -P 						\
	$WITHIPV4 $WITHIPV6					\
	-D$DB_TYPE						\
	-DSMTPIPV4=\'$SMTPIPV4\'				\
	-DSMTPIPV6=\'$SMTPIPV6\'				\
	-DSMTPPORT0=\'$SMTPPORT0\'				\
	-DSMTPPORT1=\'$SMTPPORT1\'				\
	$ONESMTPPORT2						\
	$ONESMTPPORT3						\
	-DDOMAINNAME=\'$DOMAINNAME\'				\
	-DROOTDOMAIN=\'root@$DOMAINNAME\'			\
	-DCLEMDOMAIN=\'clement.$DOMAINNAME\'			\
	-DGROUPNAME=\'`echo $DOMAINNAME | cut -d'.' -f1`\'	\
	-DHOSTNAME=\'$HOSTNAME\'				\
	-DRPASS=\'$RPASS\'					\
	-DMENTORNAME=\'$MENTORNAME\'				\
	-DMNTPORT1=\'$MNTPORT1\'				\
	-DSPAMID=\'$SPAMID\'					\
  	$fichier | 						\
	sed -es/\"/\'/g |					\
	sed '/^$/d'   |						\
	tee -a $DBSQL | 					\
	$SQL $SQLPORT $SQLHOST $DB_NAME >>  $LOG 2>&1
  /bin/echo "/*********************************************/" >>  $DBSQL
  done

