#! /bin/sh
#-------------------------------------------------------------
#procedure to create the clement data-base the first
#time the application is installed.
#-------------------------------------------------------------
#setting the basic definition
BASE=$1
. `dirname $0`/../shell/version.sh

#-------------------------------------------------------------
#loading the variable value
. $BASE/etc/sysconfig/$APPNAME

#setting the Variable
#first the Data-base type
if [ -z "$DB_TYPE" ] ; then
  DB_TYPE=POSTGRESQL;
  fi

#Then the data-base name
if [ -z "$DB_NAME" ] ; then
  DB_NAME=$APPNAME;
  fi
#-------------------------------------------------------------
#moving to the right directory
cd $1
LOG=$BASE/etc/$APPNAME-$VERS/dbinst.log
DBSQL=$BASE/etc/$APPNAME-$VERS/dbinst.sql
USER=`id -nu`
#building data_base
case "$DB_TYPE" in 
  "MYSQL"	)
    SQL="mysql -u root"
    if [ ! -z "$DB_PORT" ] ; then
      SQLPORT="-P $DB_PORT"
      fi
    if [ ! -z "$DB_HOST" ] ; then
      SQLHOST="-h $DB_HOST"
      fi
    echo "create database $DB_NAME | $SQL $SQLPORT $SQLHOST" >> $LOG
    /bin/echo "creating $DB_TYPE:$DB_NAME data-base" >> $LOG
    echo "create database $DB_NAME" | $SQL $SQLPORT $SQLHOST  >>  $LOG
    (
    /bin/echo "GRANT USAGE ON *.* TO 'apache'@'localhost';"
    /bin/echo "GRANT ALL ON  $DB_NAME.* TO '$APPNAME'@'localhost';"
    ) | $SQL $SQLPORT $SQLHOST $DB_NAME >>  $LOG
    /bin/echo "data-base is now created and full access granted to user $APPNAME" >> $LOG
    if [ "$USER" = "root" ] ; then
      #This to needed information to use CONVERT_TZ function
      (
      echo "#----------------------------------------------------"
      echo "Updating 'mysql' data-base with timezone info, needed"
      echo "to use CONVERT_TZ function"
      mysql_tzinfo_to_sql /usr/share/zoneinfo 2>/dev/null 	   |	\
		$SQL $SQLPORT $SQLHOST mysql 
      echo "#----------------------------------------------------"
      ) >> $LOG
      fi
    ;;
  "POSTGRESQL"	)
    SQL="psql -q"
    if [ ! -z "$DB_PORT" ] ; then
      SQLPORT="-p $DB_PORT"
      fi
    if [ ! -z "$DB_HOST" ] ; then
      SQLHOST="-h $DB_HOST"
      fi
    /bin/echo "creating $DB_TYPE:$DB_NAME data-base" >> $LOG
    if [ "$USER" = "root" ] ; then
      chown $APPNAME $LOG
      /bin/su - -m postgres >> $LOG << !EOT
	 echo "CREATE ROLE $APPNAME WITH LOGIN CREATEDB" |		\
		 $SQL $SQLHOST $SQLPORT template1
	 echo "CREATE ROLE apache WITH LOGIN" |				\
		 $SQL $SQLHOST $SQLPORT template1
	 echo "CREATE ROLE dovecot WITH LOGIN" |			\
		 $SQL $SQLHOST $SQLPORT template1
         /usr/bin/createdb -T template0 -E $LANG -O 			\
			 $APPNAME $SQLHOST $SQLPORT $DB_NAME
!EOT
    else    
      /usr/bin/createdb -T template0 -E $LANG -O 			\
			$USER $SQLHOST $SQLPORT $DB_NAME
      fi
    /bin/echo "data-base is now created" >> $LOG
    ;;
  "*"		)
    #undefined database type at that stage?
    ;;
  esac
