#! /bin/sh
#------------------------------------------------------------------
#Procedure that adds counters daily for super admin
#------------------------------------------------------------------
#setting up default env variable.
. `dirname $0`/../shell/version.sh
. $BASE/etc/sysconfig/$APPNAME

#setting the Variable
#first the Data-base type
if [ -z "$DB_TYPE" ] ; then
  DB_TYPE=POSTGRESQL;
  fi

#Then the data-base name
if [ -z "$DB_NAME" ] ; then
  DB_NAME=$APPNAME;
  fi

case "$DB_TYPE" in
  "POSTGRESQL"  )
     if [ ! -z "$DB_PORT" ] ; then
       SQLPORT="-p $DB_PORT"
       fi
     if [ ! -z "$DB_HOST" ] ; then
       SQLHOST="-h $DB_HOST"
       fi
     ;;
  "MYSQL"       )
     if [ ! -z "$DB_PORT" ] ; then
       SQLPORT="-P $DB_PORT"
       fi
     if [ ! -z "$DB_HOST" ] ; then
       SQLHOST="-h $DB_HOST"
       fi
     ;;
  esac
#----------------------------------------------
#procedure to probe data-base qith an SQL request
#as $1 parametere
prob_db()

{
case "$DB_TYPE" in
  "POSTGRESQL"  )
     echo "$1" | psql -t -q  -A -F ' ' $SQLPORT $SQLHOST $DB_NAME
     ;;
  "MYSQL"       )
     echo "$1" | mysql -s -u $APPNAME $SQLPORT $SQLHOST $DB_NAME
     ;;
  esac
}
#------------------------------------------------------------------
#Procedure that removes the counters older than timeDB(60) days.
clean ()
{
oldcount=`date --date "$timeDB days ago" '+%Y-%m-%d'`
prob_db "DELETE  FROM counter where cday<='$oldcount'"
}
#------------------------------------------------------------------
#Procedure that calculates ans adds to the counter yesterday.
createCounter ()
{
#taking care of the last 5 days
for jour in 5 4 3 2 1
  do
  yesterday=`date --date "$jour days ago" '+%Y-%m-%d'`
  let jour-=1;
  today=`date --date "$jour days ago" '+%Y-%m-%d'`
  if [ `prob_db "SELECT count(*) FROM counter WHERE cday='$yesterday';"` -eq 0 ] ; then
    nbtra=`prob_db "SELECT count(*) from emlogs where stamp>='$yesterday' and stamp<'$today';"`
    prob_db "INSERT INTO counter VALUES ('$yesterday',$nbtra);" 
    fi
  done
}

clean
createCounter
