#! /bin/sh
#-------------------------------------------------------------
#procedure to detect user with the deleted flag and move the whole
#directory contents to a "tobedeleted" drectory.
#-------------------------------------------------------------
#setting the basic definition
. `dirname $0`/../shell/version.sh

#-------------------------------------------------------------
#loading the variable value
. $BASE/etc/sysconfig/$APPNAME

#setting the Variable
#first the Data-base type
if [ -z "$DB_TYPE" ] ; then
  DB_TYPE=POSTGRESQL;
  fi

#Then the data-base name
if [ -z "$DB_NAME" ] ; then
  DB_NAME=$APPNAME;
  fi

#-------------------------------------------------------------
case "$DB_TYPE" in
  "POSTGRESQL"  )
     if [ ! -z "$DB_PORT" ] ; then
       SQLPORT="-p $DB_PORT"
       fi
     if [ ! -z "$DB_HOST" ] ; then
       SQLHOST="-h $DB_HOST"
       fi
     ;;
  "MYSQL"       )
     if [ ! -z "$DB_PORT" ] ; then
       SQLPORT="-P $DB_PORT"
       fi
     if [ ! -z "$DB_HOST" ] ; then
       SQLHOST="-h $DB_HOST"
       fi
     ;;
  esac

#----------------------------------------------
#procedure to probe data-base qith an SQL request
#as $1 parametere
prob_db()

{
case "$DB_TYPE" in
  "POSTGRESQL"  )
     echo "$1" | psql -t -q  -A -F ' ' $SQLPORT $SQLHOST $DB_NAME
     ;;
  "MYSQL"       )
     echo "$1" | mysql -s -u $APPNAME $SQLPORT $SQLHOST $DB_NAME
     ;;
  esac
}

#----------------------------------------------
HOME=$BASE/var/spool/$APPNAME-$VERS/
OWNER=`ls -ld $HOME | cut -d' ' -f3`
if [ `id -nu` = "$OWNER" ]; then
  mkdir -p $HOME/db_back
  if [ -f $HOME/db_back/$DB_NAME.bck.gz ] ; then
    mv -f $HOME/db_back/$DB_NAME.bck.gz $HOME/db_back/$DB_NAME.bck.gz.old
    fi
  case "$DB_TYPE" in
    "POSTGRESQL"  )
       (
       echo "-- To reload $DB_NAME data-base " 
       echo "-- if the old data-base still existing"
       echo "-- Move previous data-base \"alter database $DB_NAME rename to "$DB_NAME"_bad;\""
       echo "-- then type"
       echo "-- cat $HOME/db_back/$DB_NAME.bck | psql template1"
       echo "--"
       echo "--"
       ) > $HOME/db_back/$DB_NAME.bck
       pg_dump -C $SQLPORT $SQLHOST $DB_NAME >> $HOME/db_back/$DB_NAME.bck
       ;;
    "MYSQL"       )
       (
       echo "-- To reload $APPNAME data-base " 
       echo "-- cat $HOME/db_back/$DB_NAME.bck | mysql"
       echo "--"
       echo "--"
       ) > $HOME/db_back/$DB_NAME.bck
       mysqldump $SQLPORT $SQLHOST 				\
		--create-options --add-drop-database 		\
		--databases $DB_NAME >> $HOME/db_back/$DB_NAME.bck
       ;;
    esac
  gzip $HOME/db_back/$DB_NAME.bck
  else
    echo "Executing user need to be $APPNAME"
  fi

