#! /bin/sh
#-------------------------------------------------------------
#procedure to create the application data-base the first
#time the application is installed.
#-------------------------------------------------------------
#setting the basic definition
BASE=$1
. `dirname $0`/../shell/version.sh

#-------------------------------------------------------------
#loading the variable value
. $BASE/etc/sysconfig/$APPNAME

#setting the Variable
#first the Data-base type
if [ -z "$DB_TYPE" ] ; then
  DB_TYPE=POSTGRESQL;
  fi

#Then the data-base name
if [ -z "$DB_NAME" ] ; then
  DB_NAME=$APPNAME;
  fi
#-------------------------------------------------------------
#moving to the right directory
cd $1
LOG=$BASE/etc/$APPNAME-$VERS/dbinst.log
DBSQL=$BASE/etc/$APPNAME-$VERS/dbinst.sql
USER=`id -nu`
#building data_base
case "$DB_TYPE" in 
  "POSTGRESQL"	)
    SQL="psql -q"
    if [ ! -z "$DB_PORT" ] ; then
      SQLPORT="-p $DB_PORT"
      fi
    if [ ! -z "$DB_HOST" ] ; then
      SQLHOST="-h $DB_HOST"
      fi
    /bin/echo "creating $DB_TYPE:$DB_NAME data-base" >> $LOG
    SHSU="/bin/sh"
    if [ "$USER" = "root" ] ; then
      SHSU="/bin/su - $APPNAME"
      fi
    ;;
  "MYSQL"	)
    SQL="mysql -u root"
    if [ ! -z "$DB_PORT" ] ; then
      SQLPORT="-P $DB_PORT"
      fi
    if [ ! -z "$DB_HOST" ] ; then
      SQLHOST="-h $DB_HOST"
      fi
    SHSU="/bin/sh"
    ;;
  esac
exec $SHSU  >>  $LOG 2>&1 << !EOT
cpp -P -traditional 							\
	-D$DB_TYPE							\
	$BASE/etc/$APPNAME-$VERS/$APPNAME.tbl |				\
	sed '/^$/d' |							\
	tee -a $DBSQL |							\
	$SQL $SQLPORT $SQLHOST $DB_NAME 
!EOT
