#! /bin/sh
#-------------------------------------------------------------
#procedure to send everyone who are over $PERCENTMAX % of their quota. Default at 90%.
#-------------------------------------------------------------
#local variable
#originator filed max length
MAXORIG=30
MAXSUBJ=50
PERCENTMAX=90
#-------------------------------------------------------------
#setting the basic definition
. `dirname $0`/../shell/version.sh

#-------------------------------------------------------------
#loading the variable value
. $BASE/etc/sysconfig/$APPNAME
clmsndr="$BASE/usr/bin/clmsndr"
clmsndrBase=$clmsndr
if [ -n "$BASE" ] ; then
  clmsndrBase=$clmsndr" -b $BASE"
  fi
Error='0'
LoggerApp="logger -t clmsndr"


#setting the Variable
#first the Data-base type
if [ -z "$DB_TYPE" ] ; then
  DB_TYPE=POSTGRESQL;
  fi

#Then the data-base name
if [ -z "$DB_NAME" ] ; then
  DB_NAME=$APPNAME;
  fi

#-------------------------------------------------------------
case "$DB_TYPE" in
  "POSTGRESQL"  )
     if [ ! -z "$DB_PORT" ] ; then
       SQLPORT="-p $DB_PORT"
       fi
     if [ ! -z "$DB_HOST" ] ; then
       SQLHOST="-h $DB_HOST"
       fi
     ;;
  "MYSQL"       )
     if [ ! -z "$DB_PORT" ] ; then
       SQLPORT="-P $DB_PORT"
       fi
     if [ ! -z "$DB_HOST" ] ; then
       SQLHOST="-h $DB_HOST"
       fi
     ;;
  esac

#----------------------------------------------
#procedure to probe data-base qith an SQL request
#as $1 parametere
prob_db()

{
case "$DB_TYPE" in
  "POSTGRESQL"  )
     echo "$1" | psql -t -q  -A -F ' ' $SQLPORT $SQLHOST $DB_NAME
     ;;
  "MYSQL"       )
     echo "$1" | mysql -s -u $APPNAME $SQLPORT $SQLHOST $DB_NAME
     ;;
  esac
}

#---------------------------------------------------------
#Check the user prfid in order to determine it language.
langCheck()
{
#$1 username
case "$DB_TYPE" in
  "POSTGRESQL"  )
  EMAIL=`echo $1 | sed -e "s/'/''/" `
     ;;
  "MYSQL"       )
  EMAIL=`echo $1 | sed -e 's/'\''/\\\\'\''/'`
     ;;
  esac
prfid=`prob_db "SELECT prfid FROM users WHERE username='$EMAIL';"`
lang=`prob_db "SELECT lang FROM userprofile WHERE prfid='$prfid';"`
case "$lang" in
  2	)
    . $BASE/etc/$APPNAME-$VERS/report_francais.conf
    ;;
  1	|							\
  *	)
	. $BASE/etc/$APPNAME-$VERS/report_english.conf
    ;;
  esac
}
#transmet
#print mail to be send to one user.
#$1 'to' clement recipient

#----------------------------------------------


transmet ()

{
cat | $clmsndrBase $1 -m "$FROM"

RETVAL=$?
Error=1
        whoError="while trying to mail $username for QUOTA (Status $RETVAL)(clement sender)"
        case "$RETVAL" in
        0)
       		Error=0
	 ;;
        1)
                $LoggerApp "Unable to get local email $whoError"
        ;;
        2)
                $LoggerApp "Unable to contact remote server $whoError"
        ;;
        3)
                $LoggerApp "Originator is not accepted by remote $whoError"
        ;;
        4)
                $LoggerApp "One recipient is not Accepted $whoError"
        ;;
        5)
                $LoggerApp "Remote do not accept data $whoError"
        ;;
        6)
                $LoggerApp "Unassigned $whoError"
        ;;
        7)
                $LoggerApp "Email is not accepted by remote $whoError"
        ;;
        *)
                $LoggerApp "Unknown error in clmsndr $whoError"
        ;;
        esac
        numMail='0'

return $Error
}
#----------------------------------------------
givedate ()

{
(
LANG=$formatLang date +"$formatDate "	
)|(
export  LANG=en_US.$LANG
iconv -t $LANG  -t ASCII//TRANSLIT;
)
}
#----------------------------------------------
print_mail_header ()
#$1 user
{
        echo "From: $senderQuota <"$FROM">" 
        echo "To: "$1
        echo "$subjectQuota (`givedate`)"
        echo "Date: `date -R`"
}
#----------------------------------------------
print_header ()
#$1 recipient name
{
case "$DB_TYPE" in
  "POSTGRESQL"  )
  EMAIL=`echo $1 | sed -e "s/'/''/" `
     ;;
  "MYSQL"       )
  EMAIL=`echo $1 | sed -e 's/'\''/\\\\'\''/'`
     ;;
  esac
realname=`prob_db "SELECT realname FROM users WHERE username='$EMAIL';"`
echo "$salutation $realname,"
echo ""
echo "$headerQuota"
echo ""
}


#----------------------------------------------
print_core ()

{
echo "$bodyQuota"
}

#----------------------------------------------
print_email ()

{
case "$DB_TYPE" in
  "POSTGRESQL"  )
  EMAIL=`echo $1 | sed -e "s/'/''/" `
     ;;
  "MYSQL"       )
  EMAIL=`echo $1 | sed -e 's/'\''/\\\\'\''/'`
     ;;
  esac
domain=`echo $1 | cut -d'@' -f2`
GRP=`prob_db "SELECT groupid FROM domain WHERE domainname='$domain';"`
CLEMSRVR=`prob_db "SELECT clemserver FROM clmgroup WHERE groupid=$GRP;"`
export FROM="Noreply@$CLEMSRVR"
bytes=`prob_db "SELECT usedmgbytes FROM users where username='$EMAIL';"`
#$1 user
langCheck $1
(
print_mail_header $1 
#header separator
echo ""			
print_header $1
print_core
#print_footer
) | transmet $1
return $?
}

#----------------------------------------------
if [ -x $clmsndr ]; then
  (
  all_prfid=`prob_db "SELECT prfid from userprofile where prfid>0 order by prfid;"`
  for prfid  in $all_prfid
    do

profileMax=`prob_db "SELECT mxmgbytes FROM userprofile WHERE prfid=$prfid;"`
all_users=`prob_db 							\
		"SELECT DISTINCT username FROM users 			\
			WHERE prfid=$prfid 				\
			AND usedmgbytes>$profileMax*$PERCENTMAX/100	\
			AND usedmgbytes<$profileMax			\
			ORDER BY username;"`

  for user in $all_users
    do
    print_email $user
    Error=$?
    if [ $Error = '1' ]; then
      break
    fi
    done
  done
  )
else
  $LoggerApp "Error: Clement sender do not exist or is not accessible!!!"
fi

