#! /bin/sh
#-------------------------------------------------------------
#procedure to count space used by each email account
#-------------------------------------------------------------
#setting the basic definition
. `dirname $0`/../shell/version.sh
#---------------------------------------------------------------
#loading the variable value
. `dirname $0`/../../../../etc/sysconfig/$APPNAME
#-------------------------------------------------------------
#setting the Variable
#first the Data-base type
if [ -z "$DB_TYPE" ] ; then
  DB_TYPE=POSTGRESQL;
  fi

#Then the data-base name
if [ -z "$DB_NAME" ] ; then
  DB_NAME=$APPNAME;
  fi

#-------------------------------------------------------------
case "$DB_TYPE" in
  "POSTGRESQL"  )
     if [ ! -z "$DB_PORT" ] ; then
       SQLPORT="-p $DB_PORT"
       fi
     if [ ! -z "$DB_HOST" ] ; then
       SQLHOST="-h $DB_HOST"
       fi
     ;;
  "MYSQL"       )
     if [ ! -z "$DB_PORT" ] ; then
       SQLPORT="-P $DB_PORT"
       fi
     if [ ! -z "$DB_HOST" ] ; then
       SQLHOST="-h $DB_HOST"
       fi
     ;;
  esac
#----------------------------------------------
#procedure to probe data-base qith an SQL request
#as $1 parametere
prob_db()

{
case "$DB_TYPE" in
  "POSTGRESQL"  )
     echo "$1" | psql -t -q  -A -F ' ' $SQLPORT $SQLHOST $DB_NAME
     ;;
  "MYSQL"       )
     echo "$1" | mysql -s -u $APPNAME $SQLPORT $SQLHOST $DB_NAME
     ;;
  esac
}
#----------------------------------------------
#avoiding any race condition
LOCK=$BASE/var/lock/$APPNAME-$VERS/spacecount.lck
trap "rm -f $LOCK ; exit 1" 1 2 3 15
if [ -f $LOCK ] ; then
# the lock file already exists, so what to do?
  if [ "$(ps `cat $LOCK` | wc -l)" -gt 1 ]; then
    # process is still running
    echo "$0: quit at start: lingering process `cat $LOCK`"
    exit 1
  else
    # process not running, but lock file not deleted?
    echo " $0: orphan lock file warning. Lock file deleted."
    rm -f $LOCK
    fi
  fi
echo $$ > $LOCK
#----------------------------------------------
#scanning directory
(
cd $BASE/var/spool/$APPNAME-$VERS/mails
for dom in `ls`
  do
    (
    cd $dom
    for user in `ls`
      do
case "$DB_TYPE" in
  "POSTGRESQL"  )
  spe_user=`echo $user | sed -e "s/'/''/" `
  du_user=`echo $user | sed -e 's/'\''/\\\\'\''/'`
     ;;
  "MYSQL"       )
  spe_user=`echo $user | sed -e 's/'\''/\\\\'\''/'`
  du_user=`echo $user | sed -e 's/'\''/\\\\'\''/'`
     ;;
  esac
      flagged=`prob_db "SELECT username FROM  overuse WHERE username='$spe_user@$dom'"`
      if [ ! -z "$flagged" ] ; then
        continue
        fi
      prfid=`prob_db "SELECT prfid FROM users WHERE username='$spe_user@$dom'"`
      if [ -z "$prfid" ] ; then
        continue
        fi
      mxmgbytes=`prob_db "SELECT mxmgbytes FROM userprofile WHERE prfid=$prfid"`
      usedmgbytes=`du -m -s $user| cut -f1`

      prob_db "UPDATE users SET usedmgbytes=$usedmgbytes WHERE username='$spe_user@$dom'"
      if [ $usedmgbytes -gt $mxmgbytes ] ; then
	ratio=`echo "scale=5 ; $usedmgbytes/$mxmgbytes" | bc`
        prob_db "INSERT INTO overuse (username,ratio) VALUES ('$spe_user@$dom',$ratio)"
	fi
      done
    )
  prob_db "UPDATE domain SET usedmgbytes=`du -m -s $dom | cut -f1` WHERE domainname='$dom'"
  done
)

#before to exit
rm -f $LOCK


