#! /bin/sh
#------------------------------------------------------------------
#Procedure to convert a mailbox from clement 2.1 to clement 2.5.
#------------------------------------------------------------------
while getopts 'b:d:' OPTION
  do
    case $OPTION in
    b) BASE="$OPTARG"
		;;
    d) domain="$OPTARG"
		;;
    ?) printf "Usage %s: [-b base_path] [-d domain_name]\n" $(basename $0) >&2
                exit 2
		;;
    esac
done
#Directory that has the mailbox to maildir and addtomaildir application
mb2mdDIR=`dirname $0`/mb2md
#Directory that is the destination of the transfer.
clemDir=/var/spool/clement-2.5/mails
#Domain that must be created
if [ -z $domain ] ; then
  domain=`uname -na | cut -f 2- -d "." | cut -d " " -f 1`
fi
#Directory that is the origin of the transfer.
mailboxDir=$BASE/var/spool/clement-2.1/owmboxes/$domain

#Must be used as root. Otherwise, some privilege will be denied

if [ `id -u` = 0 ] ; then

#Is the specified origin existing?

  if [ -d $mailboxDir ] ; then
#Create the domain folder
    mkdir -p $clemDir/$domain


#strip the path and put users in a list

    all_users=`find $mailboxDir/* -maxdepth 0  -exec basename {} \;`
    (for users in $all_users
    do
#Conversion to maildir

	if [ -f $mailboxDir/$users/Mailbox ] ; then
    $mb2mdDIR $mailboxDir/$users/Mailbox $clemDir/$domain/$users/dovecot/.owm
#Moving content from new to current
if [ `ls -1 $clemDir/$domain/$users/dovecot/.owm/new/ | wc -l` -ge '1' ] ; then
  mv $clemDir/$domain/$users/dovecot/.owm/new/* $clemDir/$domain/$users/dovecot/.owm/cur/
  fi
fi
    done
)
#Changing permission so clement can read them.
    chown -R clement.mail $clemDir/$domain

  else
    echo "Specified mailbox do not exist. Exiting."
 fi

else
echo "Must be executed as root"
fi


