#! /bin/sh
#---------------------------------------------------------------
#procedure to update site data-base according upgrade version
#---------------------------------------------------------------
#Only one (optionnal) argument
#$1 base	;the testing base.
#---------------------------------------------------------------
#presetting previous version release
REL=0			
#setting the basic definition
if [ -f `dirname $0`/../shell/prev-version.sh ] ; then
  . `dirname $0`/../shell/prev-version.sh
else 
  #setting RELNUM for clement-2.1
  RELNUM=21343
  fi
if [ -n "$SUBLEV" ] ; then
  export OLDVERS=$VERSION.$LEVEL.$SUBLEV-$RELEASE
else
  export OLDVERS=$VERSION.$LEVEL.$RELEASE-$UPDATE
fi
export PRVRELNUM=$RELNUM
#---------------------------------------------------------------
#loading the variable value
. `dirname $0`/../../../../etc/sysconfig/$APPNAME
. `dirname $0`/../shell/version.sh
export CURVERS=$VERSION.$LEVEL.$RELEASE-$UPDATE
#---------------------------------------------------------------
#Database setting
#first the Data-base type
if [ -z "$DB_TYPE" ] ; then
  DB_TYPE=POSTGRESQL;
  fi

#Then the data-base name
if [ -z "$DB_NAME" ] ; then
  DB_NAME=$APPNAME;
  fi
#setting data-base parameteres
case "$DB_TYPE" in
  "POSTGRESQL"  )
     export clemapache="apache"
     if [ ! -z "$DB_PORT" ] ; then
       SQLPORT="-p $DB_PORT"
       fi
     if [ ! -z "$DB_HOST" ] ; then
       SQLHOST="-h $DB_HOST"
       fi
     SQL="psql -t -q $SQLPOR $SQLHOST"
     ;;
  "MYSQL"       )
     export clemapache="apache@localhost"
     if [ ! -z "$DB_PORT" ] ; then
       SQLPORT="-P $DB_PORT"
       fi
     if [ ! -z "$DB_HOST" ] ; then
       SQLHOST="-h $DB_HOST"
       fi
     SQL="mysql -s -u root $SQLPOR $SQLHOST"
     ;;
  esac
#---------------------------------------------------------------
#setting log file
LOGFILE=$BASE/etc/$APPNAME-$VERS/dbinst.log
UTIL=`dirname $0`/../utilitities
#---------------------------------------------------------------
#procedure to upgrade from clement-2.1
#---------------------------------------------------------------
from_210xxx()

{
echo "Warning! Conversion need to be done manually (see README)"
}
#===============================================================
#procedure to upgrade to 2.5-136-13
#adding index to table emlogs.
#---------------------------------------------------------------
upto_25136013()

{
(
echo "CREATE INDEX emlogs_rmtip ON emlogs(rmtip);"
echo "CREATE INDEX emlogs_rmthost ON emlogs(rmthostname);"
echo "CREATE INDEX emlogs_rmtsubj ON emlogs(subject);"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-138-1
#creating table ADMINLOGS
#---------------------------------------------------------------
upto_25138001()
{
(
echo "UPDATE filterinfo set bgcolor='#95B795' where code=18;"
echo "ALTER TABLE overrides ADD COLUMN auser TEXT;"
echo "ALTER TABLE emlogs ADD COLUMN taille_num INTEGER;"
echo "UPDATE emlogs set taille_num=taille::int;"
echo "ALTER TABLE emlogs rename taille to taille_bad;"
echo "ALTER TABLE emlogs rename taille_num to taille;"
echo "CREATE INDEX emlogs_taille ON emlogs (taille);"
echo "ALTER TABLE emlogs DROP COLUMN taille_bad;"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-138-12
#adding field within clmgroup table
upto_25138012()
{
(
echo "ALTER TABLE clmgroup ADD COLUMN authserver TEXT;"
echo "ALTER TABLE clmgroup ALTER COLUMN authserver SET DEFAULT NULL;"
echo "ALTER TABLE clmgroup ADD COLUMN authport TEXT;"
echo "ALTER TABLE clmgroup ALTER COLUMN authport SET DEFAULT '110';"
echo "ALTER TABLE clmgroup ADD COLUMN authproto TEXT;"
echo "ALTER TABLE clmgroup ALTER COLUMN authproto SET DEFAULT 'POP-3';"
echo "UPDATE clmgroup SET authport='110',authproto='POP-3';"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-140-1
#adding tabel seslog
upto_25140001()
{
if [ -f /etc/dovecot.conf ] ; then
  ln -s /etc/dovecot.conf /etc/$APPNAME-$VERS
  fi
(
echo "CREATE TABLE seslogs ("
echo "stamp TIMESTAMP WITH TIME ZONE DEFAULT NOW(),"
echo "sesid TEXT UNIQUE NOT NULL,"
echo "logs TEXT"
echo ");"
echo "GRANT ALL PRIVILEGES ON seslogs TO apache;"
echo "CREATE INDEX seslogs_stamp ON seslogs (stamp);"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-140-2
#adding web.clement site
upto_25140002()

{
(
echo "ALTER TABLE userprofile ADD COLUMN spamlim FLOAT;"
echo "ALTER TABLE userprofile ALTER COLUMN spamlim SET DEFAULT NULL;"
echo "UPDATE filterinfo set code=20 where code=19;"
echo "INSERT INTO filterinfo (type, code, lang, color, str, description, bgcolor)"
echo "		VALUES (1,19,1,'red','No_address','Email without valid address','#fb9090');"
echo "INSERT INTO filterinfo (type, code, lang, color, str, description, bgcolor)"
echo "		VALUES (1,19,2,'red','Sans_adresse','Courriel adresse erronn&eacute;e','#fb9090');"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-140-10
#updating field within blshosts table
upto_25140010()

{
(
echo "ALTER TABLE blshosts DROP CONSTRAINT blshosts_blsserver_key;"
echo "ALTER TABLE blshosts ALTER COLUMN blsserver SET NOT NULL;"
echo "CREATE UNIQUE INDEX blshosts_ndx ON blshosts (blsid,blsserver);"
echo "GRANT SELECT,INSERT,UPDATE,DELETE ON blshosts TO $clemapache;"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-140-11
#adding changing background color for no_address within filter info
upto_25140011()

{
(
echo "UPDATE filterinfo SET bgcolor='#f0b5bd' WHERE code=19;"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-140-12
#rename record name within domalias table.
upto_25140012()

{
(
case "$DB_TYPE" in
  "POSTGRESQL"  )
     echo "ALTER TABLE domainalias RENAME COLUMN ALIAS TO domainaliased;"
     ;;
  "MYSQL"  )
     echo "ALTER TABLE domainalias "
     echo "    CHANGE COLUMN ALIAS domainaliased VARCHAR(100);"
     ;;
  esac
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-141-2
#Creating missing index within emlogs
upto_25141002()

{
(
case "$DB_TYPE" in
  "POSTGRESQL"  )
     echo "CREATE INDEX emlogs_session ON emlogs (session);"
     ;;
  "MYSQL"  )
     echo "CREATE INDEX emlogs_session ON emlogs (session(40));"
     ;;
  esac
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-142-1
#Updating grant within domainalias table
upto_25142001()

{
(
echo "GRANT SELECT,INSERT,UPDATE,DELETE ON domainalias TO $clemapache;"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-142-2
#adding changing background color for Undefined within filter info
upto_25142002()

{
(
echo "UPDATE filterinfo SET color='black' WHERE code=20;"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-142-3
#adding traces within inqueue
upto_25142003()

{
(
echo "ALTER TABLE inqueue ADD COLUMN traces TEXT;"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-142-4
#adding relay database
upto_25142004()

{
(
case "$DB_TYPE" in
  "POSTGRESQL"  )
     echo "CREATE TABLE relay(groupid INTEGER,ipnumber TEXT,domain TEXT);"
     echo "CREATE INDEX queue_recdom_ndx ON inqueue (recdom);"
     ;;
  "MYSQL"  )
     echo "CREATE TABLE relay(groupid INTEGER,ipnumber TEXT,domain TEXT) TYPE InnoDB;"
     echo "CREATE INDEX queue_recdom_ndx ON inqueue (recdom(40));"
     ;;
  esac
echo "GRANT SELECT,INSERT,UPDATE,DELETE ON relay TO $clemapache;"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-143-5
#populating relay database
upto_25143005()

{
(
case "$DB_TYPE" in
  "POSTGRESQL"  )
     echo "GRANT SELECT ON users TO dovecot;"
     ;;
  "MYSQL"  )
     echo "GRANT SELECT ON users TO dovecot@localhost;"
     ;;
  esac
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-144-1
#populating relay database
upto_25144001()

{
echo "counters database table was prematurely set within 2.5-143 release" >> $LOGFILE
echo "DROP TABLE counter;" | tee -a $LOGFILE | $SQL $DB_NAME
(
case "$DB_TYPE" in
  "POSTGRESQL"  )
     echo "ALTER TABLE relay ADD COLUMN upto TIMESTAMP WITH TIME ZONE;"
     echo "ALTER TABLE relay ALTER COLUMN upto SET DEFAULT NULL;"
     echo "ALTER TABLE relay ADD COLUMN updated TIMESTAMP WITH TIME ZONE;"
     echo "ALTER TABLE relay ALTER COLUMN updated SET DEFAULT NOW();"
     echo "ALTER TABLE relay ALTER COLUMN ipnumber SET NOT NULL;"
     echo "CREATE UNIQUE INDEX relay_table ON relay (groupid,ipnumber,domain);"
     ;;
  "MYSQL"  )
     echo "DROP INDEX emltrt_ndx ON emltrt;";
     echo "CREATE UNIQUE INDEX emltrt_ndx ON emltrt (session(80), mfrom(80),recipient(80));";
     echo "ALTER TABLE relay ADD COLUMN upto TIMESTAMP NULL;"
     echo "ALTER TABLE relay ADD COLUMN updated TIMESTAMP NULL;"
     echo "ALTER TABLE relay CHANGE updated updated TIMESTAMP NOT NULL DEFAULT NOW();"
     echo "ALTER TABLE relay CHANGE ipnumber ipnumber VARCHAR(100) NOT NULL;"
     echo "CREATE UNIQUE INDEX relay_table ON relay (groupid,ipnumber(40),domain(40));"
     ;;
  esac
echo "CREATE INDEX relay_updated ON relay (updated);"
echo "CREATE TABLE counter(cday DATE UNIQUE NOT NULL,number INTEGER);"
echo "GRANT SELECT,INSERT,UPDATE,DELETE ON counter TO $clemapache;"
) | tee -a $LOGFILE | $SQL $DB_NAME
(
ALWAYSRELAY=/etc/clement-$VERSION.$LEVEL/alwaysrelay
NEWFILE=$ALWAYSRELAY.new
> $NEWFILE

#scanning alwaysrelay file
cat $ALWAYSRELAY        |
while read -r LINE
  do
  if [ "${LINE:0:1}" = '#' ] ; then
    echo $LINE >> $NEWFILE
  else
    if [ "${LINE:0:9}" = "127.0.0.1" ] ; then
      echo $LINE >> $NEWFILE
    else
      echo "#---$LINE" >> $NEWFILE
      echo "$LINE" | sed 's/#.*//g' |
      while read -r IPNUM DOMAIN
        do
        STRDOM="NULL"
        if [ -n "$DOMAIN" ] ; then
          STRDOM="'$DOMAIN'"
       fi
        echo "INSERT INTO relay (groupid,ipnumber,domain)       \
                VALUES (1,'$IPNUM',$STRDOM)"			\
		| tee -a $LOGFILE | $SQL $DB_NAME
        done
      fi
    fi
  done
if [ -f $NEWFILE ] ; then
  mv -f $NEWFILE $ALWAYSRELAY
  fi
)
}
#===============================================================
#procedure to upgrade to 2.5.144-4
#populating counter values for the last 60 days.
upto_25144004()

{
jour=1;
MAX=60;
while [ $jour -lt $MAX ] ; do
  day=`date --date="$jour days ago" '+%Y-%m-%d'`;
  let jour+=1;
  prev=`date --date="$jour days ago" '+%Y-%m-%d'`;
  echo "INSERT INTO counter (SELECT '$prev',count(*) FROM emlogs WHERE stamp>='$prev' AND stamp<'$day')" \
	| tee -a $LOGFILE | $SQL $DB_NAME
  done
}
#===============================================================
#procedure to upgrade to 2.5.145-12
#to reindex inqueue in a more efctive way.
upto_25145012()

{
(
case "$DB_TYPE" in
  "POSTGRESQL"  )
    echo "DROP INDEX find_queue_ndx;"
    ;;
  "MYSQL"  )
    echo "DROP INDEX \`find_queue_ndx\` ON inqueue;"
    ;;
  esac;
echo "CREATE INDEX find_queue_ndx ON inqueue (next,progress);"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5.146
#Creating cron table and changing timezone for TEXT in clmgroup
upto_25146000()

{
(
#creating CRON table
echo "CREATE TABLE cron ("
case "$DB_TYPE" in
  "POSTGRESQL"  )
    echo "cronid  SERIAL UNIQUE,";
    echo "groupid INTEGER NOT NULL,";
    echo "days TEXT NOT NULL,";
    echo "at TIME NOT NULL,";
    echo "cmd TEXT NOT NULL,";
    echo "after   TIMESTAMP WITH TIME ZONE NOT NULL";
    echo ");";
    echo "CREATE UNIQUE INDEX cron_table ON cron (groupid,days,at,cmd);";
    echo "GRANT SELECT,UPDATE ON cron_cronid_seq TO $clemapache;";
    export NTIME="now()+'-3 day'"
    ;;
  "MYSQL"  )
    echo "cronid  INTEGER AUTO_INCREMENT UNIQUE PRIMARY KEY,";
    echo "groupid INTEGER NOT NULL,";
    echo "days TEXT CHARACTER SET latin1 COLLATE latin1_bin NOT NULL,";
    echo "at TIME NOT NULL,";
    echo "cmd TEXT NOT NULL,";
    echo "after   TIMESTAMP NOT NULL";
    echo ")TYPE MyISAM;";
    echo "CREATE UNIQUE INDEX cron_table ON cron (groupid,days(80),at,cmd(80));";
    export NTIME="now()+INTERVAL -3 day"
    ;;
  esac
echo "GRANT SELECT,INSERT,UPDATE,DELETE ON cron TO $clemapache;";
echo "INSERT INTO cron (groupid,days,at,cmd,after) SELECT ";
echo "groupid,'MoTuWeThFr','8:30','/usr/lib/clement-2.5/support/sendquarlist.sh',$NTIME "
echo "FROM clmgroup;";
#updating filterinfo structure.
echo "UPDATE filterinfo set code=21 where code=20;"
echo "INSERT INTO filterinfo (type, code, lang, color, str, description, bgcolor)"
echo "		VALUES (1,20,1,'red','IP_banned','Remote IP is fully banned','#FF9900');"
case "$DB_TYPE" in
  "POSTGRESQL"  )
    echo "INSERT INTO filterinfo (type, code, lang, color, str, description, bgcolor)"
    echo "		VALUES (1,20,2,'red','IP_banni',E'IP d\'origine est banni','#FF9900');";
    ;;
  "MYSQL"  )
    echo "INSERT INTO filterinfo (type, code, lang, color, str, description, bgcolor)"
    echo "		VALUES (1,20,2,'red','IP_banni','IP d\'origine est banni','#FF9900');";
    ;;
  esac
#creating banned table.
echo "-- Adding banned table";
echo "CREATE TABLE banned (";
echo "status	INTEGER NOT NULL,";
echo "ipnum	VARCHAR(80),";
echo "mask	INTEGER NOT NULL,";
echo "iptype	INTEGER NOT NULL,";
echo "info	VARCHAR(4096) DEFAULT 'Local',";
case "$DB_TYPE" in
  "POSTGRESQL"  )
    echo "first  TIMESTAMP(0) WITH TIME ZONE DEFAULT NOW(),";
    echo "updt TIMESTAMP(0) WITH TIME ZONE,";
    echo "last  TIMESTAMP(0) WITH TIME ZONE";
    echo ");";
    ;;
  "MYSQL"  )
    echo "first  TIMESTAMP NULL DEFAULT NOW(),";
    echo "updt  TIMESTAMP NULL,";
    echo "last  TIMESTAMP NULL";
    echo ")TYPE MyISAM;";
    ;;
  esac
echo "CREATE UNIQUE INDEX banned_index ON banned (ipnum);";
echo "CREATE INDEX banned_im_index ON banned (iptype,mask);";
echo "GRANT SELECT,INSERT,UPDATE,DELETE ON banned TO $clemapache;";
case "$DB_TYPE" in
  "POSTGRESQL"  )
    echo "CREATE TABLE trusted (LIKE banned INCLUDING DEFAULTS);";
    ;;
  "MYSQL"  )
    echo "CREATE TABLE trusted (LIKE banned);";
    ;;
  esac
echo "CREATE UNIQUE INDEX trusted_index ON trusted (ipnum);";
echo "CREATE INDEX trusted_im_index ON trusted (iptype,mask);";
echo "GRANT SELECT,INSERT,UPDATE,DELETE ON trusted TO $clemapache;";
echo "CREATE TABLE ratebantrust (";
echo "ratio	FLOAT,";
echo "good	FLOAT,";
echo "total	FLOAT,";
echo "ipnum	VARCHAR(80)";
case "$DB_TYPE" in
  "POSTGRESQL"  )
    echo ");";
    ;;
  "MYSQL"  )
    echo ")TYPE MyISAM;";
    ;;
  esac
) | tee -a $LOGFILE | $SQL $DB_NAME
(
case "$DB_TYPE" in
  "POSTGRESQL"  )
    ;;
  "MYSQL"  )
    echo "UPDATING MySQL table ENGINE to MyISAM"
    SEQ1="SELECT TABLE_NAME from information_schema.TABLES where engine='innodb' and table_schema='$DB_NAME'"
    for tbl in `echo $SEQ1 | $SQL -s -r $DB_NAME`
      do
      echo "ALTER TABLE $tbl ENGINE='MyISAM'" | $SQL $DB_NAME
      done
    ;;
  esac
) >> $LOGFILE
}
#===============================================================
#procedure to upgrade to 2.5.146-4
#adding SSL Port to data-base
upto_25146004()

{
(
echo "INSERT INTO binding (port,binding,protocol,iteration) "
echo "	(SELECT 465,binding,'ssmtp',iteration FROM binding WHERE port=587);"
echo "INSERT INTO clmbind (groupid,bindid) "
echo "	(SELECT 1,bindid FROM binding WHERE protocol='ssmtp');"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5.146-11
#standardizing pop3 name (pop-3 ->pop3)
upto_25146011()

{
(
echo "ALTER TABLE clmgroup ALTER COLUMN authproto SET DEFAULT 'POP3';"
echo "UPDATE clmgroup SET authproto='POP3' WHERE authproto='POP-3';"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5.146-13
upto_25146013()

{
(
echo "-- rename cron table, time record 'after' to 'last';"
case "$DB_TYPE" in
  "POSTGRESQL"  )
     echo "ALTER TABLE cron RENAME COLUMN after TO last;"
     ;;
  "MYSQL"  )
     echo "ALTER TABLE cron "
     echo "    CHANGE COLUMN after last TIMESTAMP;"
     ;;
  esac
echo "UPDATE cron SET last=last+'-1 day' WHERE last IS NOT NULL;"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5.146-14
upto_25146014()

{
(
echo "-- adding 'needreverse' to profile flag;"
echo "ALTER TABLE userprofile ADD COLUMN needreverse INTEGER;"
echo "ALTER TABLE userprofile ALTER COLUMN needreverse SET DEFAULT 0;"
echo "UPDATE userprofile SET needreverse=0;"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-147.003
upto_25147003()

{
(
echo "-- fixing wrong status within the banned set by cron job clmtrst;"
echo "UPDATE banned SET status=2 WHERE status=1;"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-147.005
upto_25147005()

{
(
echo "-- Adding ipstd record to both trusted and banned table;"
echo "-- NOT intended to work if IP are IPV6 type (only IPV4);"
for tbl in banned trusted
  do
  case "$DB_TYPE" in
    "POSTGRESQL"  )
       echo "UPDATE $tbl SET ipnum=regexp_replace(ipnum,E'^0|^00','','g') WHERE ipnum LIKE '%.%.%.%';"
       echo "UPDATE $tbl SET ipnum=regexp_replace(ipnum,E'\\\\.0|\\\\.00','.','g') WHERE ipnum LIKE '%.%.%.%';"
       echo "ALTER TABLE $tbl ADD COLUMN ipbin inet DEFAULT '0.0.0.0';"
       echo "UPDATE $tbl SET ipbin=ipnum::inet WHERE ipnum LIKE '%.%.%.%';"
       ;;
    "MYSQL"  )
       echo "UPDATE $tbl SET ipnum=TRIM(LEADING '0' FROM ipnum);"
       echo "UPDATE $tbl SET ipnum=replace(replace(ipnum,'.0','.'),'.0','.');"
       echo "ALTER TABLE $tbl ADD COLUMN ipbin varbinary(16) DEFAULT '0.0.0.0';"
       echo "UPDATE $tbl SET ipbin=inet_aton(ipnum) WHERE ipnum like '%.%.%.%';"
       ;;
    esac
  echo "CREATE INDEX $tbl"_ipbin" ON $tbl(ipbin);"
  done
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-147.010
upto_25147010()

{
(
echo "-- ----------------------------------------"
echo "-- Changing SSL smtp protocol name from 'ssmtp' to 'smtps'"
echo "-- Resizing info size to be 8192 max;"
echo "-- Adding reverse record information to banned/trusted record;"
echo "-- and setting the reverse address for ipnum already in record;"
echo "UPDATE binding set protocol='smtps' WHERE protocol='ssmtp';"
for tbl in banned trusted
  do
  case "$DB_TYPE" in
    "POSTGRESQL"  )
       echo "ALTER TABLE $tbl ALTER info TYPE varchar(8192);"
       ;;
    "MYSQL"  )
       echo "ALTER TABLE $tbl MODIFY info VARCHAR(8192);"
       ;;
    esac
  echo "ALTER TABLE $tbl ADD COLUMN reverse TEXT;"
  done
) | tee -a $LOGFILE | $SQL $DB_NAME
(
for tbl in banned trusted
  do
  for ip in `echo "select ipnum from $tbl" | $SQL $DB_NAME`
    do
    ipshort=`echo $ip | sed -e "s/ipv6://"`;
    reverse=`dig +short -x $ipshort`;
    if [ -z "$reverse" ] ; then
      reverse="No.Reverse";
      fi
    echo "update $tbl set reverse='$reverse' where ipnum='$ip'" | $SQL $DB_NAME ;
    done
  done
) >> $LOGFILE &
}
#===============================================================
#procedure to upgrade to 2.5-148.002
upto_25148002()

{
(
echo "-- Adding imaptls authentification protocol"
echo "UPDATE clmgroup SET authproto='IMAPTLS' WHERE authproto='IMAP';"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-148.3
upto_25148003()

{
(
echo "-- Creating new table multipath;"
echo "CREATE TABLE multipath (i_email TEXT,e_email TEXT);"
case "$DB_TYPE" in
  "POSTGRESQL"  )
     echo "CREATE UNIQUE INDEX multipath_ndx ON multipath (e_email);"
     ;;
  "MYSQL"  )
     echo "CREATE UNIQUE INDEX multipath_ndx ON multipath (e_email(40));"
     ;;
  esac
echo "GRANT SELECT,INSERT,UPDATE,DELETE ON multipath TO $clemapache;"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-148.6
upto_25148006()

{
(
echo "-- Adding email MSG-ID within emlog;"
echo "ALTER TABLE emlogs ADD COLUMN msgid TEXT;"
case "$DB_TYPE" in
  "POSTGRESQL"  )
     echo "CREATE INDEX emlogs_msgid ON emlogs (msgid);"
     ;;
  "MYSQL"  )
     echo "CREATE INDEX emlogs_msgid ON emlogs (msgid(80));"
     ;;
  esac
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-148.9
upto_25148009()

{
(
echo "-- removing bl.ipv6.spameatingmonkey.net from blshosts list"
echo "DELETE FROM blshosts WHERE blsserver='bl.ipv6.spameatingmonkey.net';"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#===============================================================
#---------------------------------------------------------------
#Main process
#---------------------------------------------------------------
(
echo "#-------------------------------------------"
echo "#On" `date`
echo "#version Database upgrade from $OLDVERS to $CURVERS"
if [ $PRVRELNUM -lt 25000 ] ; then
  from_210xxx
  fi
if [ $PRVRELNUM -lt 25136013 ] ; then
  upto_25136013
  fi
if [ $PRVRELNUM -lt 25138001 ] ; then
  upto_25138001
  fi
if [ $PRVRELNUM -lt 25138012 ] ; then
  upto_25138012
  fi
if [ $PRVRELNUM -lt 25140001 ] ; then
  upto_25140001
  fi
if [ $PRVRELNUM -lt 25140002 ] ; then
  upto_25140002
  fi
if [ $PRVRELNUM -lt 25140010 ] ; then
  upto_25140010
  fi
if [ $PRVRELNUM -lt 25140011 ] ; then
  upto_25140011
  fi
if [ $PRVRELNUM -lt 25140012 ] ; then
  upto_25140012
  fi
if [ $PRVRELNUM -lt 25141002 ] ; then
  upto_25141002
  fi
if [ $PRVRELNUM -lt 25142001 ] ; then
  upto_25142001
  fi
if [ $PRVRELNUM -lt 25142002 ] ; then
  upto_25142002
  fi
if [ $PRVRELNUM -lt 25142003 ] ; then
  upto_25142003
  fi
if [ $PRVRELNUM -lt 25142004 ] ; then
  upto_25142004
  fi
if [ $PRVRELNUM -lt 25143005 ] ; then
  upto_25143005
  fi
if [ $PRVRELNUM -lt 25144001 ] ; then
  upto_25144001
  fi
if [ $PRVRELNUM -lt 25144004 ] ; then
  upto_25144004
  fi
if [ $PRVRELNUM -lt 25145012 ] ; then
  upto_25145012
  fi
if [ $PRVRELNUM -lt 25146000 ] ; then
  upto_25146000
  fi
if [ $PRVRELNUM -lt 25146004 ] ; then
  upto_25146004
  fi
if [ $PRVRELNUM -lt 25146011 ] ; then
  upto_25146011
  fi
if [ $PRVRELNUM -lt 25146013 ] ; then
  upto_25146013
  fi
if [ $PRVRELNUM -lt 25146014 ] ; then
  upto_25146014
  fi
if [ $PRVRELNUM -lt 25147003 ] ; then
  upto_25147003
  fi
if [ $PRVRELNUM -lt 25147005 ] ; then
  upto_25147005
  fi
if [ $PRVRELNUM -lt 25147010 ] ; then
  upto_25147010
  fi
if [ $PRVRELNUM -lt 25148002 ] ; then
  upto_25148002
  fi
if [ $PRVRELNUM -lt 25148003 ] ; then
  upto_25148003
  fi
if [ $PRVRELNUM -lt 25148006 ] ; then
  upto_25148006
  fi
if [ $PRVRELNUM -lt 25148009 ] ; then
  upto_25148009
  fi
) >> $LOGFILE 2>&1
