#! /bin/sh
#---------------------------------------------------------------
#procedure to update site data-base according upgrade version
#---------------------------------------------------------------
#Only one (optionnal) argument
#$1 base	;the testing base.
#---------------------------------------------------------------
#presetting previous version release
REL=0			
#setting the basic definition
if [ -f `dirname $0`/../shell/prev-version.sh ] ; then
  . `dirname $0`/../shell/prev-version.sh
else 
  #setting RELNUM for clement-2.1
  RELNUM=21343
  fi
if [ -n "$SUBLEV" ] ; then
  export OLDVERS=$VERSION.$LEVEL.$SUBLEV-$RELEASE
else
  export OLDVERS=$VERSION.$LEVEL.$RELEASE-$UPDATE
fi
export PRVRELNUM=$RELNUM
#---------------------------------------------------------------
#loading the variable value
. `dirname $0`/../../../../etc/sysconfig/$APPNAME
. `dirname $0`/../shell/version.sh
export CURVERS=$VERSION.$LEVEL.$RELEASE-$UPDATE
#---------------------------------------------------------------
#Database setting
#first the Data-base type
if [ -z "$DB_TYPE" ] ; then
  DB_TYPE=POSTGRESQL;
  fi

#Then the data-base name
if [ -z "$DB_NAME" ] ; then
  DB_NAME=$APPNAME;
  fi
#setting data-base parameteres
case "$DB_TYPE" in
  "POSTGRESQL"  )
     if [ ! -z "$DB_PORT" ] ; then
       SQLPORT="-p $DB_PORT"
       fi
     if [ ! -z "$DB_HOST" ] ; then
       SQLHOST="-h $DB_HOST"
       fi
     SQL="psql -q $SQLPOR $SQLHOST"
     ;;
  "MYSQL"       )
     if [ ! -z "$DB_PORT" ] ; then
       SQLPORT="-P $DB_PORT"
       fi
     if [ ! -z "$DB_HOST" ] ; then
       SQLHOST="-h $DB_HOST"
       fi
     SQL="mysql -u root $SQLPOR $SQLHOST"
     ;;
  esac
#---------------------------------------------------------------
#setting log file
LOGFILE=$BASE/etc/$APPNAME-$VERS/dbinst.log
UTIL=`dirname $0`/../utilitities
#---------------------------------------------------------------
#procedure to upgrade from clement-2.1
#---------------------------------------------------------------
from_210xxx()

{
echo "Warning! Conversion need to be done manually (see README)"
}
#===============================================================
#procedure to upgrade to 2.5-140-2
#adding web.clement site
upto_25140002()

{

insert()

{
cat >> /etc/httpd/conf/web_$APPNAME.conf <<!EOT
<VirtualHost $1:80>
	ServerName web.clement.$domain
	ServerAdmin root@$domain
	DirectoryIndex menclem.php
	DocumentRoot /var/web/$APPNAME-$VERS
	Alias /base-graph/ /var/www/$APPNAME-$VERS/graph/
	<Directory /var/web/$APPNAME-$VERS>
		Options MultiViews FollowSymlinks
		AllowOverride AuthConfig FileInfo Indexes Limit Options
		Order allow,deny
		Allow from all
	</Directory>
	ErrorLog logs/webmerr.log
	TransferLog logs/weblog-ssl.log
</VirtualHost>

!EOT
}

export hostipv4=`dig \`uname -n\` A +noall +short`;
export hostipv6=`dig \`uname -n\` AAAA +noall +short`;

if [ -z "$domain" ] ; then
  export domain=`dnsdomainname`
  fi

#to make sure we have at least an hostipv4 reference
if [ -z "$hostipv4" -a -z "$hostipv6" ] ; then
  export hostipv4=`grep \`uname -n\` /etc/hosts | cut  -f1`
  fi
insert $hostipv4

if [ -n "$hostipv6" ] ; then
  insert $hostipv6
  fi

cat >> /etc/httpd/conf/$APPNAME.conf <<!EOT

#$APPNAME START
include	/etc/httpd/conf/web_$APPNAME.conf
#$APPNAME STOP
!EOT

#to restart httpd with the new web definition
service httpd restart

}
#===============================================================
#procedure to upgrade to 2.5-141-3
#moving  web.clement working directory
upto_25141003()

{
if [ -f /etc/httpd/conf/web_$APPNAME.conf ] ; then
  sed -i -e"s/\/var\/web\/clement-2.5/\/var\/www\/clement-2.5\/web/" \
	/etc/httpd/conf/web_$APPNAME.conf
  fi
if [ -f /etc/httpd/conf/$APPNAME.conf ] ; then
  sed -i -e"s/\/var\/web\/clement-2.5/\/var\/www\/clement-2.5\/web/" \
	/etc/httpd/conf/$APPNAME.conf
  fi
service httpd restart
}
#===============================================================
#procedure to upgrade to 2.5-143-5
#populating relay database
upto_25143005()

{
case "$DB_TYPE" in
  "POSTGRESQL"  )
     /bin/su - -m postgres >> $LOGFILE << !EOT
	echo "CREATE ROLE dovecot WITH LOGIN" | $SQL template1
!EOT
     ;;
  "MYSQL"  )
     ;;
  esac
}
#===============================================================
#procedure to upgrade to 2.5-146-4
#moving clement httpd configuration file to conf.d
upto_25146004()

{
if [ -d /etc/httpd/conf.d ] ; then
  if [ -f /etc/httpd/conf/$APPNAME.conf ] ; then
    mv /etc/httpd/conf/$APPNAME.conf /etc/httpd/conf.d
    sed -i -e'/#clement/{N;N;d;}' /etc/httpd/conf/httpd.conf
    service httpd restart    
    sleep 10
    fi
  fi
}
#===============================================================
#procedure to upgrade to 2.5-146-4
#restarting httpd to include new php.imap module
upto_25146011()

{
echo "#Now restarting httpd to include php.imap module"
service httpd restart    
sleep 10
}
#---------------------------------------------------------------
#---------------------------------------------------------------
#Main process
#---------------------------------------------------------------
#make sure the log file existing and own by application
touch $LOGFILE
chown $APPNAME.mail $LOGFILE
(
echo "#-------------------------------------------"
echo "#On" `date`
echo "#version files upgrade from $OLDVERS to $CURVERS"
if [ $PRVRELNUM -lt 25000 ] ; then
  from_210xxx
  fi
if [ $PRVRELNUM -lt 25140002 ] ; then
  upto_25140002
  fi
if [ $PRVRELNUM -lt 25141003 ] ; then
  upto_25141003
  fi
if [ $PRVRELNUM -lt 25143005 ] ; then
  upto_25143005
  fi
if [ $PRVRELNUM -lt 25146004 ] ; then
  upto_25146004
  fi
if [ $PRVRELNUM -lt 25146011 ] ; then
  upto_25146011
  fi
) >> $LOGFILE 2>&1
(
echo "#==========================================="
echo "Removing /var/crash/$APPNAME-$VERSION.$LEVEL core dump file"
rm -fr /var/crash/$APPNAME-$VERSION.$LEVEL/core.*
echo "#==========================================="
) >> $LOGFILE
